<?php
session_name('EduXiigle');
session_start();

//ini_set('memory_limit', 8000000); // en octets
//set_time_limit(600); // en secondes

// changer la variable suivante si le nom d'admin_groupes n'est pas admin_groupes
// exemple : $admin_groupes='autre_nom';
$admin_groupes='admin_groupes';

include_once('ressources/fonctions.php'); 

//Deconnexion
if (isset($_GET['destroy'])){
	ddt();
	session_unset();
	session_destroy();
	session_name('EduXiigle');
	session_start();

//nettoyage ancienne version eduxiigle
if (file_exists('env.php')) {exec('rm env.php');}
if (file_exists('apropos.php')) {exec('rm apropos.php');}
if (file_exists('paccueil.php')) {exec('rm paccueil.php');}

}

//htaccess
if (file_exists('htaccess')) {rename('htaccess','.htaccess');}

//verification de l'ip (brute force)
if (file_exists('securite/'.$_SERVER["REMOTE_ADDR"])) {
	$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"], 'r+');
	$n = fgets($fichier);
	fclose($fichier);
	$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"].'_date', 'r+');
	$nt = fgets($fichier);
	fclose($fichier);
  if (time() > $nt+(24*3600)) {
		unlink('securite/'.$_SERVER["REMOTE_ADDR"]);
		unlink('securite/'.$_SERVER["REMOTE_ADDR"].'_date');
		$n=0;
	}
	if ($n > 8) { 
	echo 'Trop de tentatives de connexion ont &#233;t&#233; faites depuis cette ip ('.$_SERVER["REMOTE_ADDR"].')<br>Merci de patienter 24 heures.';
	die();
	}
}

//Theme couleur par defaut
if (!isset($_SESSION['couleurs'])) {
	$Ecouleurs = array('#97b1ca','#8299AE');
} else {
	$Ecouleurs=$_SESSION['couleurs'];
}

if (!isset($_SESSION['theme'])) {
	$theme = $_SESSION['theme'] = 't1';
} else {
	$theme = $_SESSION['theme'];
}

//Taille par d&#233;faut
if (!isset($_SESSION['taille'])) {
	$fontsize=$_SESSION['taille']=14;
} else {
	$fontsize=$_SESSION['taille'];
}

//cle crytpage
$cle="";
for ($i=1;$i<21;$i++) {
	$cle.=mt_rand(100,500).'-';
}
if (!isset($_SESSION['connexion_cle'])) {
	$_SESSION['connexion_cle'] = $cle;
}

//Identification
$choisir_rep = false;
if (isset($_POST['user'])){
	$Euser=str_replace(' ','',suppr($_POST['user']));
	$tabmdp=explode('-',$_POST['pass']);
	$tabcle=explode('-',$_SESSION['connexion_cle']);
	$Epass="";
	for ($i=0;$i<count($tabmdp) - 1;$i++) {
		$Epass.=chr($tabmdp[$i] - $tabcle[$i]);
	}
	if ($Euser == ''){$Euser='?';}
	if ($Epass == ''){$Epass='?';}
	//test d'authentification
	exec('echo showconnect | /usr/bin/smbclient -b 1200 -U '.$Euser.'%"'.$Epass.'" //localhost/'.$Euser,$test);
	
	if (preg_match('#.*LOGON_FAIL.*#',$test[0])) {
		$err_connect = 2;
	} else {
	//authentification réussi
	//if ($test[0] == '//localhost/'.$Euser){
		$err_connect = 0;
		$_SESSION['user']=$Euser;
		$_SESSION['pass']=$Epass;
		$_SESSION['admin_groupes']=$admin_groupes;
		//Répertoires par défaut
		$_SESSION['reperso'] = array('erreur_rep_eduxiigle');
		//taille par defaut
		$_SESSION['fontsize']=14;
		//liste classe
		$_SESSION['listegr'] = listegr();
		//liste élèves et groupe de chaque élève
		$_SESSION['liste_eleves'] = array();
		$_SESSION['groupes_eleves'] = array();
		foreach ($_SESSION['listegr'] as $groupe) {
			$_SESSION['liste_eleves'][$groupe] = listeusers($groupe);
			foreach ($_SESSION['liste_eleves'][$groupe] as $eleve){
				$_SESSION['groupes_eleves'][$eleve] = $groupe;
			}
		}
		if (count($_SESSION['liste_eleves']) == 0) {
				$err_connect = 1;
		} else {
				$_SESSION['connect'] = 'ok';
		}
		$_SESSION['tmp']='tmp_'.$_SESSION['user'];
		if (file_exists($_SESSION['tmp'])) {ddt();$alertmp=true;}
		cdt();
		//fichier config
		cpsmbtmp('localhost',$_SESSION['user'],'Travail/.eduxiigle','config');
		if ($fichier = @fopen($_SESSION['tmp'].'/config', 'r')) {
			$unsz=unserialize(fgets($fichier));
			if (is_array($unsz['reperso'])) {
				$_SESSION['reperso']=$unsz['reperso'];
			}
			if (isset($unsz['theme'])) {
				$theme=$_SESSION['theme']=$unsz['theme'];
			}
			fclose($fichier);
			//unlink($_SESSION['tmp'].'/config');
			ddt();
		}
		if ($_SESSION['reperso'][0] == 'erreur_rep_eduxiigle') {
			$choisir_rep = true;
		}
	} //else {
		//$err_connect = 2;
	//}
}

//envoi de fichiers
if ($_GET['up'] == 'ok' and !isset($_POST['upload'])) {
	$_SESSION['uprep'] = 'Le fichier ne doit pas dépasser 8 Mo';
}

if ($_GET['up'] == 'gdf' and !isset($_POST['upload'])) {
	$_SESSION['up_gdf'] = 'Le fichier ne doit pas dépasser 8 Mo';
}

if (isset($_POST['upload']) && $_SESSION['connect'] == 'ok') {
	$up=($_POST['upload'] == 'gdf' ? 'up_gdf' : 'uprep');
	cdt();
	$name_file=$_FILES['fichier']['name'];
	$nfichier = suppr(remac($name_file));
	$nfichier = preg_replace("/([^.\ \(\)a-z0-9]+)/i", '-', $nfichier);
	$nfichier = preg_replace("/\.php.?$/i", '.scriptphp', $nfichier);
	$nfichier = preg_replace("/\.cgi$/i", '.scriptcgi', $nfichier);
	$nfichier = preg_replace("/\.sh$/i", '.scriptsh', $nfichier);
	$nfichier = preg_replace("/\.pl$/i", '.scriptpl', $nfichier);

	$tmp_file=$_FILES['fichier']['tmp_name'];
	/*if( preg_match('#[\x00-\x1F\x7F-\x9F/\\\\]#', $name_file) ) {
    $_SESSION['uprep'] = 'Nom de fichier non valide';
	}
	else*/ 
	if ($_FILES['fichier']['error'] == 1) {
		$_SESSION[$up] = 'Le fichier ne doit pas dépasser 8 Mo';
	}
	elseif ($_FILES['fichier']['error'] == 3 or $_FILES['fichier']['error'] == 4) {
		$_SESSION[$up] = 'Problème lors du téléchargement';
		if ($nfichier == '') {
			$_SESSION[$up] = 'Séléctionnez un fichier !';
		}	}
	elseif( !@move_uploaded_file($tmp_file,$_SESSION['tmp'].'/'.$nfichier) ) {
		$_SESSION[$up] = 'Erreur !!!';
	}
	else {
	$_SESSION[$up] = 'done';
	$_SESSION['upname'] = $nfichier;
		if ($_POST['upload'] == 'gdf') {
			unset($_SESSION['upname']);
			$verif=ls($_SESSION['gdf_serveur'],$_SESSION['gdf_partage'],$_SESSION['gdf_dossier']);
			if (array_key_exists($nfichier,$verif)) {
				$_SESSION[$up] = 'Fichier déjà existant';
			} else {
				$_SESSION['gdf_upr']=cptmpsmbr($_SESSION['gdf_serveur'],$_SESSION['gdf_partage'],$_SESSION['gdf_dossier'],$nfichier);
			}
		}
	}

/*	if ($_POST['copie'] == 'on') {
		if ($_POST['repsave'] == '- Choisir -') {
			$_SESSION['uprep'].='<br>Copie non effectuée';
		} else {
			cptmpsmb($_SESSION['rep_save']['serveur'],$_SESSION['rep_save']['partage'],$_SESSION['rep_save']['dossier'].'/'.$_POST['repsave'],$name_file);
		}
	}
*/
	exec("/bin/dd if=/dev/zero of=test_espace count=1 bs=1000000",$r);
	exec("/usr/bin/du -b test_espace",$r);
	if (!file_exists('test_espace') or (file_exists('test_espace') and substr($r[0],0,7) != "1000000")) {
		$_SESSION[$up] = "Erreur : il n'y a pas assez d'espace temporaire.<br> Demandez à l'administrateur du réseau d'augmenter le quota du compte eduxiigle.";
		unset($_SESSION['upname']);
		exec('rm '.$_SESSION['tmp'].'/'.$nfichier);
		exec('rm test_espace');
	} else {
		exec('rm test_espace');
	}
}

$_SESSION['colors'] = array();

$cb1 = "#b0987e";
$_SESSION['colors']['message'] = $_SESSION['colors']['titre'] = $ctitre = "#3c7265";

if ($theme == 't2') {
	$cb1 = "#79a9b6";
	$_SESSION['colors']['message'] = $_SESSION['colors']['titre'] = $ctitre = "#312d80";
}

$_SESSION['colors']['1'] = $c1 = change_color($cb1,-15);
$_SESSION['colors']['2'] = $c2 = change_color($cb1,+50);
$_SESSION['colors']['3'] = $c3 = $cb1;
$_SESSION['colors']['4'] = $c4 = change_color($cb1,+15);
$_SESSION['colors']['5'] = $c5 = change_color($cb1,-180);

$fontsize=14;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd" >
<html>
<head>
<meta content="text/html; charset=UTF-8" http-equiv="content-type">
<title>EduXiigle</title>
<script language="javascript" type="text/javascript" src="ressources/fonctions.js"></script>
<script>document.oncontextmenu = "return(false);"</script>
<!--[if IE]>
<script defer type="text/javascript" src="ressources/pngfix.js"></script>
<![endif]-->
<style>

body {
    behavior: url("ressources/csshover.htc");
	background-color : <?php echo $c5; ?>;
  }

.cadre {
    border-color : dimgray;
    border-style : solid;
    border-width : 1px;
	border-radius : 6px;
	padding : 15px;
   }
  
.menu {
    border-color : dimgray;
    border-style : solid;
    border-width : 1px;
	border-radius : 3px;
    background-color : <?php echo $c3; ?>;
    text-align : center;
  }

.menunc {
    border-color : dimgray;
    border-style : solid;
    border-width : 1px;
	border-radius : 3px;
    background-color : <?php echo $c3; ?>;
    text-align : center;
    color : #b7b7b7;
  }

.confirmation {
    border-color : black;
    border-style : solid;
    border-width : 1px;
	border-radius : 3px;
    background-color : <?php echo $c3; ?>;
    text-align : center;
    padding : 5px;
  }

.menu:hover {
    cursor: pointer;
    background-color : <?php echo $c4; ?>;
  }


.efichier {
    color : black;
    text-decoration : none;
  }

.gdff:hover {
    background-color : <?php echo $c3; ?>;
  }

.lienjs {
    color : <?php echo $ctitre; ?>;
    cursor : pointer;
    text-decoration : underline;
  }

.lieng {
    color : <?php echo $ctitre; ?>;
    cursor : pointer;
  }

.lieng:hover {
    background-color : <?php echo $c3; ?>;
  }


td,input,select {
	font-size:<?php echo $fontsize;?>px;
	font-family : sans-serif;
	line-height:140%;
	
}

.titre {
	color : <?php echo $ctitre; ?> ;
	font-size : 32px;
	font-weight:bold;
	padding-top : 5px;
	padding-bottom : 20px;
}

#ident {
	background-position: 100% 2px;
	background-repeat:no-repeat;
	padding-right : 16px;
	padding-top : 8px;
	text-align : right;
	height : 50px ;
	color : black ;
	font-family : monospace;
}

span.taille2 {font-size:<?php echo $fontsize-1;?>px;}
span.taille4 {font-size:<?php echo $fontsize-3;?>px;}

</style>
</head>

<body link="<?php echo $ctitre; ?>" alink="<?php echo $ctitre; ?>" vlink="<?php echo $ctitre; ?>" onload="init()">
<div style="position : absolute ; top : 8px ; bottom : 8px; right : 8px ; left : 8px;">

<div style="position : absolute ; top : 5px; right : 5px ; left : 5px;"><center><img src="media/logo<?php echo ($theme == 't2')?'t2':'t1';?>.png"></center></div>

<table width="1260px" border="0" cellspacing="0" align="center" bgcolor="<?php echo $c1; ?>" id="tabprincipal" style="border-color : dimgray; border-style : solid; border-width : 1px; height : 100%; border-radius : 6px;">
<tbody>
<tr height="50px" >
<td width="150px" align="center" align="left" id="chargement" style="color : #555555;"></td>
<td width="250px"></td>
<td align="center" valign="middle" id="image_titre_eduxiigle" style="font-size : 42px ; color : <?php echo $clogo; ?>;font-family : monospace;"></td>
<td width="400px" valign="top">
<?php if ($_SESSION['connect'] == 'ok'){
$user=$_SESSION['user'];
if  (strlen($user) > 15) {
	echo '<span style="position:absolute"><img src="media/trombone.png" style="position:relative;top:-7px;right:-210px;"></span>';
	echo '<div id="ident" style="background-image : url(media/feuillel.png);">';
	if  (strlen($user) > 22) {
		$user=substr($user,0,19).'...';
	}
} else {
	echo '<span style="position:absolute"><img src="media/trombone.png" style="position:relative;top:-7px;right:-260px;"></span>';
	echo '<div id="ident" style="background-image : url(media/feuille.png);">';
}
echo $user;
echo '<br><a href="index.php?destroy" style="color : black; position :relative;">déconnexion</a></div>';
} else {
	echo '<div id="ident" style="background-image : url(media/feuille.png); visibility : hidden;"></div>';
}
?>
</td>
</tr>
<tr>
<td valign="top" align="center" id="tabmenu" style="padding-left : 6px; padding-top : 40px; padding-bottom : 5px;"></td>
<td colspan="3" valign="top" style="padding-right : 10px;padding-bottom : 10px;">
<table cellspacing="4" cellpadding="4" width="100%" height="100%">
<tr><td valign="top" class="cadre" id="main" style="background-color : <?php echo $c2; ?>;background-image : url(media/);background-position:right bottom;background-repeat:no-repeat;">
<span id="jstest">Attention ! Votre navigateur n'accepte pas le javascript<br>Sans javascript, EduXiigle est malheureusement inutilisable...</span>
<script>document.getElementById('jstest').innerHTML = '';</script>
<?php if ($choisir_rep == false or $err_connect == 1) { ?>
<script>ajax('ressources/menu.php','','tabmenu');</script>
<?php } ?>
<?php
if (isset($_GET['apropos'])) {
include('ressources/apropos.php');
}
elseif (!isset($_SESSION['uprep']) and !isset($_SESSION['up_gdf'])) {
	if ($choisir_rep == true and $err_connect != 1) {
		include('ressources/changerep.php');
		//echo '<script>premiereconnexion();</script>';
	} else {
		
		include('ressources/paccueil.php'); ?>
		<table width="100%" align="center">
		<tr>
		<td align="center" id="verifauth">
		<?php if ($err_connect == 2) {

			if (file_exists('securite/'.$_SERVER["REMOTE_ADDR"])) {
				$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"].'_date', 'r+');
				fputs($fichier,time());
				fclose($fichier);
				$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"], 'r+');
				$n = fgets($fichier);
				$n++;
				fseek($fichier, 0);
				fputs($fichier,$n);
				if ($n==7) {
					echo '<font color=#CD0000>Erreur de connexion (8)<br><br>Attention, il vous reste 2 tentatives</font>';
				}
				elseif ($n==8) {
					echo '<font color=#CD0000>Erreur de connexion (9)<br><br>Attention, il vous reste 1 tentative</font>';
				}
				elseif ($n>8) {
					echo '<font color=#CD0000><blink>Ordinateur bloqu&#233;</blink></font>';
				}
				else {
					echo '<font color=#CD0000>Erreur de connexion ('.($n+1).')</font>';
				}
				fclose($fichier);
			} else {
				$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"], 'w+');
				fputs($fichier,'0');
				fclose($fichier);
				$fichier = fopen('securite/'.$_SERVER["REMOTE_ADDR"].'_date', 'w+');
				fputs($fichier,time());
				fclose($fichier);
				echo '<font color=#CD0000>Erreur de connexion (1)</font>';
			}
		}

		if ($err_connect == 1) {
			echo '<font color=#CD0000>Vous n\'avez aucun groupe en responsabilité (\\\\'.$admin_groupes.')</font>';
		} ?>
		</td>
		<td width="150px"></td>
		</tr>
		</table>
<?php } }?>
</td></tr>
</table>

</td>
</tr>
</tbody>
</table>
</div>

<?php if ($_GET['up'] == 'ok') { ?><script>document.getElementById('main').innerHTML ='Merci de patienter...';ajax('envoi.php','','main');</script><?php } ?>
<?php if ($_GET['up'] == 'gdf') { ?><script>document.getElementById('main').innerHTML ='Merci de patienter...';ajax('ressources/gdf.php','','main');</script><?php } ?>
<?php if ($alertmp) { ?><script>alert('Vous ne vous êtes pas déconnecté lors de la dernière utilisation.\n\nPensez-y à la fin de cette session ! (en haut à gauche)')</script><?php } ?>
<?php if (isset($_GET['config'])) { ?><script>javascript:ajax('config.php','','main');</script><?php } ?>
</body>
</html>
<?php
if (isset($err_connect) and $err_connect > 0) {
	ddt();
}
//<div style="font-size : 10px; text-align : right; font-family : sans-serif;">2014 - <a href="http://www.xiigle.org">www.xiigle.org</a></div>
?>
